//mohammad shokri
#ifndef PIO_INCLUDED_
#define PIO_INCLUDED_

#include "AT91SAM7X256.H"
//#include "lib_AT91SAM7X256.h"     

//input & output
#define PORT_A       AT91C_BASE_PIOA // EX: Output(PORT_A,0xFFFFFFFF);
#define PORT_B       AT91C_BASE_PIOB // EX: Input(PORT_B,0xFFFFFFFF); 
//#define Output       AT91F_PIO_CfgOutput // EX: Output(PORT_B,0xFFFFFFFF);
//#define Input        AT91F_PIO_CfgInput // EX: Input(PORT_A,0xFFFFFFFF);
//#define Pullup       AT91F_PIO_CfgPullup // EX: Pullup(PORT_A,0xFFFFFFFF);
//#define PMC_En       AT91F_PMC_EnablePeriphClock // EX: PMC_En(PMC, 1 << PIO_A);
#define PMC          AT91C_BASE_PMC // EX: PMC_En(PMC, 1 << PIO_A);
#define PIO_B        AT91C_ID_PIOB // EX: PMC_En(PMC, 1 << PIO_B); 
#define PIO_A        AT91C_ID_PIOA // EX: PMC_En(PMC, 1 << PIO_B);
//#define Read         AT91F_PIO_GetInput  // EX: (Read(PORT_A) & PA_27) == 0
//#define Clr_Out      AT91F_PIO_ClearOutput // EX: Clr_Out(PORT_B,0x07800000);
//#define Set_Out      AT91F_PIO_SetOutput // EX: Set_Out(PORT_B,0x00780000);
//#define PIO_En_Int   AT91F_PIO_InterruptEnable // EX: PIO_Int_En(PORT_B,0x00780000);
//#define PIO_Dis_Int  AT91F_PIO_InterruptDisable // EX: PIO_Int_Dis(PORT_B,0x00780000);
//#define Dis_Filter   AT91F_PIO_InputFilterDisable // EX: Dis_Filter(PORT_B,0x00780000);
//#define En_Filter    AT91F_PIO_InputFilterEnable

//Start Port A
#define PA_0 AT91C_PIO_PA0 // PINA_0
#define PA_1 AT91C_PIO_PA1
#define PA_2 AT91C_PIO_PA2
#define PA_3 AT91C_PIO_PA3
#define PA_4 AT91C_PIO_PA4
#define PA_5 AT91C_PIO_PA5
#define PA_6 AT91C_PIO_PA6
#define PA_7 AT91C_PIO_PA7
#define PA_8 AT91C_PIO_PA8
#define PA_9 AT91C_PIO_PA9
#define PA_10 AT91C_PIO_PA10
#define PA_11 AT91C_PIO_PA11
#define PA_12 AT91C_PIO_PA12
#define PA_13 AT91C_PIO_PA13
#define PA_14 AT91C_PIO_PA14
#define PA_15 AT91C_PIO_PA15
#define PA_16 AT91C_PIO_PA16
#define PA_17 AT91C_PIO_PA17
#define PA_18 AT91C_PIO_PA18
#define PA_19 AT91C_PIO_PA19
#define PA_20 AT91C_PIO_PA20
#define PA_21 AT91C_PIO_PA21
#define PA_22 AT91C_PIO_PA22
#define PA_23 AT91C_PIO_PA23
#define PA_24 AT91C_PIO_PA24
#define PA_25 AT91C_PIO_PA25
#define PA_26 AT91C_PIO_PA26
#define PA_27 AT91C_PIO_PA27
#define PA_28 AT91C_PIO_PA28
#define PA_29 AT91C_PIO_PA29
#define PA_30 AT91C_PIO_PA30
//Start Port B
#define PB_0 AT91C_PIO_PB0
#define PB_1 AT91C_PIO_PB1
#define PB_2 AT91C_PIO_PB2
#define PB_3 AT91C_PIO_PB3
#define PB_4 AT91C_PIO_PB4
#define PB_5 AT91C_PIO_PB5
#define PB_6 AT91C_PIO_PB6
#define PB_7 AT91C_PIO_PB7
#define PB_8 AT91C_PIO_PB8
#define PB_9 AT91C_PIO_PB9
#define PB_10 AT91C_PIO_PB10
#define PB_11 AT91C_PIO_PB11
#define PB_12 AT91C_PIO_PB12
#define PB_13 AT91C_PIO_PB13
#define PB_14 AT91C_PIO_PB14
#define PB_15 AT91C_PIO_PB15
#define PB_16 AT91C_PIO_PB16
#define PB_17 AT91C_PIO_PB17
#define PB_18 AT91C_PIO_PB18
#define PB_19 AT91C_PIO_PB19
#define PB_20 AT91C_PIO_PB20
#define PB_21 AT91C_PIO_PB21
#define PB_22 AT91C_PIO_PB22
#define PB_23 AT91C_PIO_PB23
#define PB_24 AT91C_PIO_PB24
#define PB_25 AT91C_PIO_PB25
#define PB_26 AT91C_PIO_PB26
#define PB_27 AT91C_PIO_PB27
#define PB_28 AT91C_PIO_PB28
#define PB_29 AT91C_PIO_PB29
#define PB_30 AT91C_PIO_PB30//PB_30
//End Port B


__inline void PIO_Periph(AT91PS_PIO pPio ,unsigned int periphA_En ,unsigned int periphB_En)
{
 pPio->PIO_ASR = periphA_En;
 pPio->PIO_BSR = periphB_En;
 pPio->PIO_PDR = (periphA_En | periphB_En); // Set in Periph mode // PDR = PIO Disable Register
}//Ex: PIO_Periph(PORT_B,PB_19 | PB_27);

//------------------------------------------------------------------------------------------------
__inline void PIO_Opendrain(AT91PS_PIO pPio,unsigned int multiDrvEnable) // \arg pio to be configured in open drain
{
	// Configure the multi-drive option
	pPio->PIO_MDDR = ~multiDrvEnable;
	pPio->PIO_MDER = multiDrvEnable;
}

//------------------------------------------------------------------------------------------------
__inline void Input(
	AT91PS_PIO pPio,             // \arg pointer to a PIO controller
	unsigned int inputEnable)      // \arg PIO to be enabled
{
	// Disable output
	pPio->PIO_ODR  = inputEnable;
	pPio->PIO_PER  = inputEnable;
}

//------------------------------------------------------------------------------------------------
__inline void Output(
	AT91PS_PIO pPio,             // \arg pointer to a PIO controller
	unsigned int pioEnable)      // \arg PIO to be enabled
{
	pPio->PIO_PER = pioEnable; // Set in PIO mode
	pPio->PIO_OER = pioEnable; // Configure in Output
}

//------------------------------------------------------------------------------------------------
__inline void En_Filter(
        AT91PS_PIO pPio,   // \arg  pointer to a PIO controller
        unsigned int flag) // \arg  pio input filter to be enabled
{
        pPio->PIO_IFER = flag;
}

//------------------------------------------------------------------------------------------------
__inline void Dis_Filter(
        AT91PS_PIO pPio,   // \arg  pointer to a PIO controller
        unsigned int flag) // \arg  pio input filter to be disabled
{
        pPio->PIO_IFDR = flag;
}

//------------------------------------------------------------------------------------------------
__inline void PIO_En_Int(
        AT91PS_PIO pPio,   // \arg  pointer to a PIO controller
        unsigned int flag) // \arg  pio interrupt to be enabled
{
        pPio->PIO_IER = flag;
}

//------------------------------------------------------------------------------------------------
__inline void PIO_Dis_Int(
        AT91PS_PIO pPio,   // \arg  pointer to a PIO controller
        unsigned int flag) // \arg  pio interrupt to be disabled
{
        pPio->PIO_IDR = flag;
}

//------------------------------------------------------------------------------------------------
__inline void Set_Out(
	AT91PS_PIO pPio,   // \arg  pointer to a PIO controller
	unsigned int flag) // \arg  output to be set
{
	pPio->PIO_SODR = flag;
}

//------------------------------------------------------------------------------------------------
__inline void Clr_Out(
	AT91PS_PIO pPio,   // \arg  pointer to a PIO controller
	unsigned int flag) // \arg  output to be cleared
{
	pPio->PIO_CODR = flag;
}
//------------------------------------------------------------------------------------------------
/*__inline void SetClr_Out(
	AT91PS_PIO pPio,   // \arg  pointer to a PIO controller
	unsigned int flag) // \arg  output to be cleared
{
	pPio->PIO_ODSR = flag;
}*/
//------------------------------------------------------------------------------------------------
__inline unsigned int Read( // \return PIO input
	AT91PS_PIO pPio) // \arg  pointer to a PIO controller
{
	return pPio->PIO_PDSR;
}

//------------------------------------------------------------------------------------------------
__inline void Pullup(
	AT91PS_PIO pPio,             // \arg pointer to a PIO controller
	unsigned int pullupEnable)   // \arg enable pullup on PIO
{
		// Connect or not Pullup
	pPio->PIO_PPUDR = ~pullupEnable;
	pPio->PIO_PPUER = pullupEnable;
}

//------------------------------------------------------------------------------------------------
__inline void PMC_En (
	AT91PS_PMC pPMC, // \arg pointer to PMC controller
	unsigned int periphIds)  // \arg IDs of peripherals
{
	pPMC->PMC_PCER = periphIds;
}

//------------------------------------------------------------------------------------------------
#endif

//89/6/25
//2010/9/16 // 5 hour

